/*

Fast image steganography routines and classes

(c)  2009 Alexander Myasnikov

Russia, Vladimir region, Kolchugino

Uses 9 bits of one pixel, 3 bit of one color and 24-bit images.

i.e. for one byte is needed only 0,88 pixels.

WEB: www.darksoftware.narod.ru

E-mail: darksoftware@ya.ru

Free for non-commercial usage

If you like this code and want to use it

in commercial software, please contact author.

 */

typedef unsigned char *TBitA;
typedef unsigned char *TIMA;

const unsigned short int Header = 0xFEAD;

class TIMFile {

protected:

	TBitA BitA;
	TIMA IMA;
	int BitAPos;
	int LengthBitA;
	int ima_size;
	int ima_h;
	int ima_w;
	bool Injected;

public:
	int Estimated;
	int stegotype;

	void LoadImage(String fn);
	void SaveImage(String fn);
	void LoadToBA(String fn);
	void SaveToBA(String fn);
	void Inject();
	void Catch();
	bool CheckHeader(String fn);
	unsigned char GetBit();
	void PutBit(unsigned char b);
	void PutByte(unsigned char b);
	void PutInteger(int b);
	void PutWord(unsigned short int b);
	unsigned char GetByte();
	int GetInteger();
	unsigned short int GetWord();
	int changebits(unsigned char v);
	void getbits(unsigned char v);

	TIMFile();
	~TIMFile();

};
